unit mouse;
{$F+,O+}
interface
type GrMask = record
       X,Y : word;
       mask : array[0..1,0..15] of Word;
     end;
Function  MouseIsPresent : boolean;     { Zjistuje jestli je mys instalovana }
Procedure ShowPointer;                  { Zobrazeni mysiho kurzoru }
Procedure HidePointer;                  { Schovani mysiho kurzoru }
Procedure GetMousePos(var X,Y : Word);  { Nancteni mysich souradnic do promenne }
Procedure SetMousePos(X,Y : Word);      { Nastaveni mysich souradnic }
Procedure SetMouseMask(Maska : GrMask); { Nastaveni masky kurzoru }
Function  Mx : Word;                    { Zjisti horizontalni pozici mysi }
Function  My : Word;                    { Zjisti vertikalni pozici mysi }
Function  Mgx : Word;                   { Zjisti horizontalni grafickou pozici mysi }
Function  Mgy : Word;                   { Zjisti vertikalni grafickou pozici mysi }
Procedure  SetMx(X : Word);             { Nastavi horizontalni pozici mysi }
Procedure  SetMy(Y : Word);             { Nastavi vertikalni pozici mysi }
Function  LPress : boolean;             { Zjisteni stisku leveho tlacitka mysi }
Function  RPress : boolean;             { Zjisteni stisku praveho tlacitka mysi }

{Tlacitka}
const LeftBut = 0;
      MiddBut = 2;
      RighBut = 1;

{Souradnice vztaznych bodu kurzoru mysi}
const SipkaX   = 0;
      SipkaY   = 0;
      KrizX    = 7;
      KrizY    = 7;
      HodinyX  = 8;
      HodinyY  = 8;
      OtaznikX = 5;
      OtaznikY = 5;
      ListecekX= 0;
      ListecekY= 0;
      KrizekX  = 7;
      KrizekY  = 3;
      FatcursX = 0;
      FatcursY = 0;
      PogocursX= 7;
      PogocursY= 7;
{Masky grafickych kurzoru}
const Kursor   : GrMask =   (X:5;   Y:5;  mask:
                            (( $3FFF, $1FFF, $0FFF, $07FF,
                              $03FF, $01FF, $00FF, $007F,
                              $003F, $001F, $001F, $00FF,
                              $30FF, $F87F, $F87F, $FC7F ),

                            ( $0000, $4000, $6000, $7000,
                              $7800, $7C00, $7E00, $7F00,
                              $7F80, $7FC0, $7C00, $4600,
                              $0600, $0300, $0300, $0000 )));

      Kriz     : GrMask =  (X:krizX;  Y:krizY; mask:
                           (( $FFFF, $FFFF, $FFFF, $FFFF,
                              $FFFF, $FFFF, $FFFF, $FFFF,
                              $FFFF, $FFFF, $FFFF, $FFFF,
                              $FFFF, $FFFF, $FFFF, $FFFF ),

                            ( $0100, $0100, $0100, $0100,
                              $0100, $0000, $0000, $F93E,
                              $0000, $0000, $0100, $0100,
                              $0100, $0100, $0100, $0000 )));

      Hodiny   : GrMask =  (X:hodinyX; Y:hodinyY;  mask:
                           (( $F839, $E008, $C004, $8003,
                              $8003, $0001, $0001, $0001,
                              $0001, $0001, $8003, $8003,
                              $C007, $E00F, $F83F, $FFFF ),

                            ( $07C6, $1FF7, $383B, $600C,
                              $600C, $C006, $C006, $DF06,
                              $C106, $C106, $610C, $610C,
                              $3838, $1FF0, $07C0, $0000 )));

      Otaznik  : GrMask =  (X:otaznikX; Y:otaznikY;  mask:
                           (( $FFFF, $C0FF, $807F, $987F,
                              $FC7F, $F87F, $E0FF, $C3FF,
                              $C7FF, $C7FF, $C7FF, $FFFF,
                              $C7FF, $C7FF, $C7FF, $FFFF ),

                            ( $0000, $3E00, $6700, $0300,
                              $0300, $0600, $1800, $3000,
                              $3000, $3000, $0000, $0000,
                              $3000, $3000, $0000, $0000 )));

      Sipka    : GrMask =  (X: sipkaX; Y : sipkaY; mask:
                           (( $003F, $003F, $003F, $07FF,
                              $03FF, $11FF, $18FF, $1C7F,
                              $1E3F, $1F1F, $FF8F, $FFCF,
                              $FFFF, $FFFF, $FFFF, $FFFF ),

                            ( $0000, $7F80, $6000, $5000,
                              $4800, $4400, $4200, $4100,
                              $4080, $1010, $0000, $0000,
                              $0000, $0000, $0000, $0000 )));


      Listecek : GrMask =  (X: listecekX;Y:listecekY;mask:
                           (( $3FFF, $1FFF, $0FFF, $07FF,
                              $03FF, $01FF, $00FF, $007F,
                              $007F, $00FF, $10FF, $F8FF,
                              $FFFF, $FFFF, $FFFF, $FFFF ),

                            ( $0000, $4000, $6000, $7000,
                              $7800, $7C00, $7E00, $7F00,
                              $7F00, $6C00, $0600, $0000,
                              $0000, $0000, $0000, $0000 )));

      Krizek   : GrMask =  (X: krizekX; Y:krizekY; mask:
                           (( $F1FF, $F1FF, $F1FF, $001F,
                              $001F, $001F, $F1FF, $F1FF,
                              $F1FF, $FFFF, $FFFF, $FFFF,
                              $FFFF, $FFFF, $FFFF, $FFFF ),

                            ( $0000, $0400, $0400, $0400,
                              $7FC0, $0400, $0400, $0400,
                              $0000, $0000, $0000, $0000,
                              $0000, $0000, $0000, $0000 )));

      Fatcurs  : GrMask =  (X:fatcursX; Y:fatcursY; mask:
                           (( $007F, $007F, $007F, $007F,
                              $003F, $001F, $000F, $0007,
                              $0003, $F001, $F800, $FC01,
                              $FE03, $FF07, $FF8F, $FFDF ),

                            ( $0000, $7F00, $7F00, $7F00,
                              $7F80, $7FC0, $7FE0, $7FF0,
                              $0FF8, $07FC, $03FE, $01FC,
                              $00F8, $0070, $0020, $0000 )));

      Pogocurs : GrMask =  (X:PogocursX; Y:PogocursY; mask:
                           (( $1999, $6666, $6676, $1646,
                              $7666, $7999, $FFFF, $FFFF,
                              $9909, $6696, $6697, $0199,
                              $659C, $6696, $6699, $FFFF ),

                            ( $E666, $9999, $9989, $E9B9,
                              $8999, $8666, $0000, $0000,
                              $66F6, $9969, $9968, $FE66,
                              $9A63, $9969, $9966, $0000 )));

      Obdelnik : grMask =  (X: 0; Y: 0; mask :
                           (( $FFFF, $FFFF, $FFFF, $FFFF,
                              $FFFF, $FFFF, $FFFF, $FFFF,
                              $FFFF, $FFFF, $FFFF, $FFFF,
                              $FFFF, $FFFF, $FFFF, $FFFF),

                            ( $FF00, $FF00, $FF00, $FF00,
                              $FF00, $FF00, $FF00, $FF00,
                              $FF00, $FF00, $FF00, $FF00,
                              $FF00, $FF00, $FF00, $FF00 )));

     Mec      : grMask =  (X: 8; Y: 0; mask :
                           (( $FFFF, $FFFF, $FFFF, $FFFF,
                              $FFFF, $FFFF, $FFFF, $FFFF,
                              $FFFF, $FFFF, $FFFF, $FFFF,
                              $FFFF, $FFFF, $FFFF, $FFFF),

                            ( $0080, $0140, $0360, $0770,
                              $0770, $0770, $0770, $0770,
                              $0770, $0770, $1C1C, $1C1C,
                              $03E0, $03E0, $03E0, $01C0 )));

     LRuka    : grMask =  (X: 8; Y: 0; mask :
                           (( $FFFF, $FFFF, $FFFF, $FFFF,
                              $FFFF, $FFFF, $FFFF, $FFFF,
                              $FFFF, $FFFF, $FFFF, $FFFF,
                              $FFFF, $FFFF, $FFFF, $FFFF),

                            ( $0DB0, $1248, $7248, $9248,
                              $9248, $9248, $9248, $9248,
                              $924E, $9249, $9249, $9249,
                              $9249, $8001, $8001, $6006 )));

     RRuka    : grMask =  (X: 8; Y: 0; mask :
                           (( $F24F, $EDB7, $EDB1, $EDB6,
                              $EDB6, $EDB6, $EDB6, $EDB6,
                              $8DB6, $6DB6, $6DB6, $6DB6,
                              $6DB6, $7FFE, $7FFE, $9FF9),

                            ( $0DB0, $1248, $124E, $1249,
                              $1249, $1249, $1249, $1249,
                              $7249, $9249, $9249, $9249,
                              $9249, $8001, $8001, $6006 )));



Implementation
uses dos;
var
  regs : registers;
Function MouseIsPresent : boolean;
begin
  regs.ax:=0;
  intr($33,regs);
 if regs.ax = 0 then
    MouseIsPresent := false
 else
    MouseIsPresent := true;
end;
Procedure ShowPointer;
begin
  regs.ax:=1;
  intr($33,regs);
end;
Procedure HidePointer;
begin
  regs.ax:=2;
  intr($33,regs);
end;
Procedure GetMousePos(var X,Y : Word);
var
  X1,Y1 : word;
begin
  regs.ax:=3;
  intr($33,regs);
  X1:=regs.cx;
  Y1:=regs.dx;
  X:= (X1 div 8)+1;
  Y:= (Y1 div 8)+1;
end;
Procedure SetMousePos(X,Y : Word);
begin
  X:= (X-1)*8;
  Y:= (Y-1)*8;
  regs.ax:=4;
  regs.cx:= X;
  regs.dx:= Y;
  intr($33,regs);
end;
Function Mx : word;
var
  X : word;
begin
  regs.ax:=3;
  intr($33,regs);
  X:= regs.cx;
  Mx:= (X div 8)+1;
end;
Function My : word;
var
  Y : word;
begin
  regs.ax:=3;
  intr($33,regs);
  Y:= regs.dx;
  My:= (Y div 8) + 1;
end;
Function Mgx : word;
var
  X : word;
begin
  regs.ax:=3;
  intr($33,regs);
  X:= regs.cx;
  Mgx:= X;
end;
Function Mgy : word;
var
  Y : word;
begin
  regs.ax:=3;
  intr($33,regs);
  Y:= regs.dx;
  Mgy:= Y;
end;
Procedure SetMx(X : word);
begin
  X:= (X-1)*8;
  regs.ax:=4;
  regs.cx:= X;
  intr($33,regs);
end;
Procedure SetMy(Y : word);
begin
  Y:= (Y-1)*8;
  regs.ax:=4;
  regs.dx:= Y;
  intr($33,regs);
end;
Function LPress : boolean;
begin
  regs.ax:=3;
  intr($33,regs);
  LPress:=(regs.bx and 1) <> 0;
end;
Function RPress : boolean;
begin
  regs.ax:=3;
  intr($33,regs);
  RPress:=(regs.bx and 2) <> 0;
end;
procedure SetMouseMask(Maska : GrMask);
begin
  with maska do
    begin
      regs.bx := X;
      regs.cx := Y;
      regs.es := seg(mask);
      regs.dx := ofs(mask);
      regs.ax :=9;
    end;
  intr($33,regs);
end;
end.